<script lang="ts">
import Vue from 'vue';
import { NextStepAlt } from '~/components/common';
import {
  AnimatedHero,
  ColumnGroup,
  DownloadForm,
  StatsGrid,
  SurveyBanner,
  SurveyGlowPills,
  SurveyHero,
  SurveyLinks,
  SurveyQuoteCarousel,
  SurveyRegionBubbles,
  SurveyRoleBubbles,
  SurveyStatBarsSection,
  SurveyTabs,
} from '~/components/developer-survey';

export default Vue.extend({
  components: {
    Hero: AnimatedHero,
    ColumnGroup,
    StatsGrid,
    SurveyBanner,
    SurveyTabs,
    NextStepAlt,
    DownloadForm,
    SurveyLinks,
    SurveyHero,
    SurveyStatBarsSection,
    SurveyGlowPills,
    SurveyRegionBubbles,
    SurveyRoleBubbles,
    SurveyQuoteCarousel,
  },
  props: {
    survey: {
      required: true,
      type: Object,
      default: () => {},
    },
  },
});
</script>

<template>
  <div class="developer-survey">
    <SlpContainer variant="charcoal-100" class="slp-overflow-hidden">
      <Hero :data="survey.hero" class="slp-mt-32" />
    </SlpContainer>
    <div :class="survey.intro.variant">
      <component
        :is="component.name"
        v-for="(component, index) in survey.intro.components"
        :key="component.name + `-${index}`"
        class="section"
        :class="component.data.variant"
        :data="component.data"
      />
    </div>
    <SurveyBanner
      v-if="survey.survey_banner"
      :data="survey.survey_banner.data"
    />
    <div :class="survey.survey_tabs.variant">
      <SurveyTabs :data="survey.survey_tabs.tabs" />
    </div>
    <div class="light">
      <SlpContainer id="download" class="slp-px-16">
        <DownloadForm :data="survey.download.form_block" />
        <SurveyLinks :data="survey.download.links_block" />
      </SlpContainer>
    </div>
    <SlpContainer variant="gradient" class="slp-px-16">
      <NextStepAlt />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.developer-survey {
  overflow: clip;
  .section {
    margin: $spacing-96 0;
  }
  .dark {
    background-color: $color-surface-700;
    padding: 1px 0;
    color: $color-primary-300;
    &:first-child {
      margin-top: 0;
    }
  }
  .light {
    background-color: #f1edfc;
  }
  :deep {
    .slp-container {
      position: relative;
    }
    .column-group p {
      margin-bottom: $spacing-16;
    }
  }
}
</style>
